/*
 * Oelmesser.c
 *
 * Created: 22.04.2013 21:01:01
 *  Author: Uwe
 */ 


#include <avr/io.h>
#include <stdlib.h>
#include <avr/interrupt.h>
#include <inttypes.h>
#include "lcd-routines.h"
#include "lcd-routines.c"
#include <util/delay.h>
//#define F_CPU 16000000UL  //schon in der lcd-routines.h erledigt


volatile unsigned short zaehler1 = 0;  //Pumpeneingang Nachkommastelle
volatile unsigned short zaehler2 = 0;  //Pumpeneingang Vorkommastelle
volatile unsigned short zaehler3 = 0;  //Pumpenausgang Nachkommastelle
volatile unsigned short zaehler4 = 0;  //Pumpenausgang Vorkommastelle
volatile unsigned short zaehler5 = 0;  //Anzeige fr zwei Nachkommastellen Pumpeneingang
volatile unsigned short zaehler6 = 0;  //Anzeige fr zwei Naxhkommastellen Pumpenausgang
volatile unsigned short zaehler7 = 0;  //Hilfszhler fr korrekte Nachkommastellenberechnung
volatile unsigned short result1 = 0;   //Verbrauch Nachkommastellen
volatile unsigned short result2 = 0;   //Verbrauch Vorkommastellen
volatile unsigned int millisekunden = 0;


void long_delay(uint16_t ms)
{
	for(; ms>0; ms--) _delay_ms(1);
}



 
 ISR(INT0_vect)
 {
	 cli();
	 zaehler1=zaehler1+4; //Durchflussmesser 2500 Impulse per Liter anpassen je nach Sensor
	 sei();
 }
 
 ISR(INT1_vect)
 {
	 cli();
	 zaehler3=zaehler3+4; //Durchflussmesser 2500 Impulse per Liter anpassen je nach Sensor
	 sei();
 }


int main(void)
{
 
	MCUCR |= (1<<ISC11) | (1<<ISC10) | (1<<ISC01) | (1<<ISC00); //fr steigende Flanke an INT0 und INT1
	GICR |= (1<<INT1) | (1<<INT0); // beide externe Interrupts aktivieren 
	DDRD  = 0x0C; /* Pin 3 und 4 von Port D als Eingang */
	PORTD = 0x0C; /* interne Pull-Ups an diesen Port-Pins aktivieren */
	
	while(1)
    {
        sei();
		 if (zaehler1>9999)
		 {
			 zaehler2++;
			 zaehler1 = zaehler1-10000;
		 }
		 if (zaehler3>9999)
		 {
			 zaehler4++;
			 zaehler3 = zaehler3-10000;
		 }		
		if (zaehler1<zaehler3)
		{
			zaehler7=zaehler1+10000;
			result1=zaehler7-zaehler3;
			zaehler7=0;
			result2=zaehler2-zaehler4-1;
		}
		if (zaehler1==zaehler3)
		{
			result1=zaehler1-zaehler3;
			result2=zaehler2-zaehler4;	
		}
		if (zaehler1>zaehler3)
		{
		result1=zaehler1-zaehler3;
		result2=zaehler2-zaehler4;	
		}
		zaehler5=zaehler1/100;
		zaehler6=zaehler3/100;
		//start Ausgabe
		lcd_init();
		
		// ... ausgeben
		lcd_setcursor(0,1);
		lcd_data( 'i' );   //Durchfluss Pumpeneingang
		{
			char Buffer1[20]; // in diesem {} lokal
			itoa( zaehler2, Buffer1, 10 );
			lcd_string( Buffer1 );
		}
		lcd_data( ',' );
		{
			char Buffer2[20]; // in diesem {} lokal mit Formatierung der fhrenden Null
			itoa( zaehler5, Buffer2, 10 );
			if (zaehler5<10)
			{
				lcd_data('0');
			}
			lcd_string( Buffer2 );
		}
		lcd_setcursor(8,1);
		lcd_data( 'o' );   //Durchfluss Pumpenausgang
		{
			char Buffer3[20]; // in diesem {} lokal
			itoa( zaehler4, Buffer3, 10 );
			lcd_string( Buffer3 );
		}
		lcd_data( ',' );
		{
			char Buffer4[20]; // in diesem {} lokal mit Formatierung der fhrenden Null
			itoa( zaehler6, Buffer4, 10 );
			if (zaehler6<10)
			{
				lcd_data('0');
			}
			lcd_string( Buffer4 );
		}
		long_delay(10);       // Zehn Millisekunden warten...
		lcd_setcursor(0,2);
		lcd_data( 'r' );   // Ausgabe tatschlicher Verbrauch
		{
			char Buffer5[20]; // in diesem {} lokal
			itoa( result2, Buffer5, 10 );
			lcd_string( Buffer5 );
		}
		lcd_data( ',' );
		{
			char Buffer6[20]; // in diesem {} lokal mit Formatierung der fhrenden Nullen
			itoa( result1, Buffer6, 10 );
			if (result1<10)
			{
					lcd_data('0');	
			}
			if (result1<100)
			{
					lcd_data('0');
			}
			if (result1<1000)
			{
					lcd_data('0');
			}
			lcd_string( Buffer6 );
		}
		long_delay(100);       // Einhundert Millisekunden warten...

    }
}